/* ATOSORT sorts AutoSig Message Files by Thread and Time and Date */

#include <ctype.h>
#include <graph.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

main(argc,argv)
int argc;
char *argv[];
{
    FILE *in, *out, *tp1, *tp2;   /* declare four FILE pointers */
    int i = 0;                    /* loop counter */
    int j = 0;                    /* loop counter */
    int incount = 0;              /* counter for input records */
    int outcount = 0;             /* counter for output records */
    int extflag = 0;              /* flag to signal extension use */
    char name[79] = "name";       /* storage for output file name */
    char buname[79] = "buname";   /* storage for backup file name */
    char str[75] = "str";         /* temp storage to strip ext off filename */
    char daterec[13] = "daterec"; /* storage for time and date record */
    char recstr[81] = "resctr";   /* string to hold input record */
    char thrstr[41] = "thrstr";   /* string to hold subject of thread */
    char clrstr[41] =             /* string to hold blanks to clr thread */
        "1234567890123456789012345678901234567890";
    char str1 = '.';
    char dot = '.';
    char numsign = '#';
    char colin = ':';
    char *tfile1;
    char *tfile2;

    /* initialize cltstr string with blanks */
    strset(clrstr, ' ' );

    /* initialize video */
    _setvideomode( _TEXTC80 );
    _clearscreen( _GCLEARSCREEN );

    /* make cursor disappear */
    _asm
        {
        mov    cl, 0
        mov    ch, 32
        mov    ah, 1
        int    10h
        }

    /* display heading info */
    printf("\n");
    printf("ATOSORT Program. [Version 1.0]  Program to sort AutoSig files.\n" );
    printf("Copyright (C) Wes Stillwell 1991.  All rights reserved.");
    printf("\n");
    printf("\n");

    /* check if there is an input file */
    if ( argc < 2 )
    {
        printf("\n");
        printf("The Name of the File to Sort is Missing.\n");
        printf("\n");
        printf("Correct Usage: ATOSORT Filename [Where Filename is the");
        printf(" Name of the\n");
        printf("               File to be Sorted.  Be Sure to Include the");
        printf(" Path if\n");
        printf("               the File is Not in the Current Directory].\n");
        printf("\n");
        goto eoj;
    }

    strcpy(name,argv[1]); /* copy file name into array */

    /* strip off extension on input filename if it exist */
    for ( i=0; i<75; i++ )
        {
        str1=name[i];
        if ( str1 == dot )
            extflag=1;
        if ( extflag == 0 )
            str[i]=name[i];
        }

    strcpy(buname,str);    /* copy file name into array */
    strcat(buname,".bak"); /* append .bak to filename */
    strcpy(name,str);      /* copy file name into array */
    strcat(name,".ato");   /* append .ato to filename */

    /* check for input file */
    if ( (in = fopen(name, "r")) == NULL)
    {
        printf("\n");
        printf("Program Aborted.  The file %s cannot be found.\n", name );
        printf("Please check the spelling of the filename and the path.\n");
        printf("\n");
        goto eoj;
    }
    fclose(in);

    /* check for already exisiting backup file */
    if ( (in = fopen(buname, "r")) != NULL)
    {
        printf("\n");
        printf("Program Aborted.  The file %s already exists.\n", buname );
        printf("\n");
        goto eoj;
    }
    fclose(in);

    /* rename ato file to bak */
    if(rename(name, buname) != 0)
    {
        perror("Renaming Ato File to Bak Failed.  Program Aborted.\n");
        printf("\n");
        goto eoj;
    }

    /* create temporary filename1 */
    tfile1 = tempnam(NULL, "wes");
    if (tfile1 == NULL)
    {
        printf("\n");
        printf("Program Aborted.  Unable to open temporary work file.\n" );
        printf("\n");
        goto eoj;
    }

    /* open temporary file1 */
    if ( (tp1 = fopen(tfile1, "w+")) == NULL)
    {
        printf("\n");
        printf("Program Aborted.  Unable to open temporary work file.\n" );
        printf("\n");
        goto eoj;
    }

    /* create temporary filename2 */
    tfile2 = tempnam(NULL, "wes");
    if (tfile2 == NULL)
    {
        printf("\n");
        printf("Program Aborted.  Unable to open temporary work file.\n" );
        printf("\n");
        goto eoj;
    }

    /* open temporary file2 */
    if ( (tp2 = fopen(tfile2, "w+")) == NULL)
    {
        printf("\n");
        printf("Program Aborted.  Unable to open temporary work file.\n" );
        printf("\n");
        goto eoj;
    }

    /* open input file */
    if ( (in = fopen(buname, "r")) == NULL)
    {
        printf("\n");
        printf("Program Aborted.  The file %s cannot be found.\n", name );
        printf("\n");
        goto eoj;
    }

    /* open output file */
    out = fopen(name, "w");
    printf("\n");
    printf(" Sorting file %s\n", name);

    /* read in records for count and sort info */
    i=0;
    extflag=0;
    printf(" Reading in message ");
    while ( fgets(recstr, 80, in) != NULL )
    {
        i++;
        str1=recstr[0];
        if ( str1 == numsign )
            extflag=1;
        str1=recstr[1];
        if ( ( str1 == 'b' ) && ( extflag == 2 ))
            extflag=3;
        if ( ( str1 == 'm' ) && ( extflag == 4 ))
            extflag=5;
        if ( ( str1 == 'o' ) && ( extflag == 6 ))
            extflag=7;
        str1=recstr[2];
        if ( ( str1 == ' ' ) && ( extflag == 1 ))
            extflag=2;
        if ( ( str1 == colin ) && ( extflag == 3 ))
        {
            extflag=4;
            for ( j=0; j<40; j++ )
            {
                thrstr[j]=recstr[j];
            }
        }
        if ( ( str1 == colin ) && ( extflag == 5 ))
            extflag=6;
        if ( ( str1 == colin ) && ( extflag == 7 ))
            extflag=8;
        if ( extflag == 2 )
        {
            j=2;
            while (isalpha(recstr[j]) == 0)
                j++;
            daterec[0]=recstr[j+4];
            daterec[1]=recstr[j+5];
            if ( ( recstr[j] == 'J' ) && ( recstr[j+1] == 'a' ))
            {
                daterec[2]='0';
                daterec[3]='1';
            }
            if ( ( recstr[j] == 'F' ) && ( recstr[j+1] == 'e' ))
            {
                daterec[2]='0';
                daterec[3]='2';
            }
            if ( ( recstr[j] == 'M' ) && ( recstr[j+2] == 'r' ))
            {
                daterec[2]='0';
                daterec[3]='3';
            }
            if ( ( recstr[j] == 'A' ) && ( recstr[j+1] == 'p' ))
            {
                daterec[2]='0';
                daterec[3]='4';
            }
            if ( ( recstr[j] == 'M' ) && ( recstr[j+2] == 'y' ))
            {
                daterec[2]='0';
                daterec[3]='5';
            }
            if ( ( recstr[j] == 'J' ) && ( recstr[j+1] == 'u' ))
            {
                daterec[2]='0';
                daterec[3]='6';
            }
            if ( ( recstr[j] == 'J' ) && ( recstr[j+2] == 'l' ))
            {
                daterec[2]='0';
                daterec[3]='7';
            }
            if ( ( recstr[j] == 'A' ) && ( recstr[j+1] == 'u' ))
            {
                daterec[2]='0';
                daterec[3]='8';
            }
            if ( ( recstr[j] == 'S' ) && ( recstr[j+1] == 'e' ))
            {
                daterec[2]='0';
                daterec[3]='9';
            }
            if ( ( recstr[j] == 'O' ) && ( recstr[j+1] == 'c' ))
            {
                daterec[2]='1';
                daterec[3]='0';
            }
            if ( ( recstr[j] == 'N' ) && ( recstr[j+1] == 'o' ))
            {
                daterec[2]='1';
                daterec[3]='1';
            }
            if ( ( recstr[j] == 'D' ) && ( recstr[j+1] == 'e' ))
            {
                daterec[2]='1';
                daterec[3]='2';
            }
            daterec[4]=recstr[j-3];
            daterec[5]=recstr[j-2];
            j=j+6;
            while (isdigit(recstr[j]) == 0)
                j++;
            daterec[6]=recstr[j];
            daterec[7]=recstr[j+1];
            daterec[8]=recstr[j+3];
            daterec[9]=recstr[j+4];
            daterec[10]=recstr[j+6];
            daterec[11]=recstr[j+7];
        }
        if ( extflag == 8 )
        {
            incount++;
            _settextposition( 7, 31 );
            printf("%s", clrstr );
            _settextposition( 7, 21 );
            printf("%d  %s", incount, thrstr );
            _settextposition( 7, 21 );
            printf("%d  %s", incount, thrstr );
            j=2;
            while (isalpha(thrstr[j]) == 0)
                j++;
            for ( extflag=0; extflag<30; extflag++ )
            {
                str[extflag]=thrstr[j];
                j++;
            }
            j=0;
            extflag=0;
            rewind( tp1 );
            while ( fgets(thrstr, 80, tp1) != NULL )
            {
                j++;
                if ( strcmp( thrstr,str ) == 0 )
                    extflag=j;
            }
            strcpy(thrstr, str);
            if ( extflag == 0 )
            {
                fputs(thrstr, tp1);
                extflag=j+1;
            }
            /* writes thread number, date & time, and rec pos */
            if ( extflag < 10 )
                fprintf( tp2, "00%d%s %d\n", extflag, daterec, i-4 );
            if ( ( extflag > 9 ) && ( extflag < 100 ))
                fprintf( tp2, "0%d%s %d\n", extflag, daterec, i-4 );
            if ( extflag > 99 )
                fprintf( tp2, "%d%s %d\n", extflag, daterec, i-4 );
            extflag=0;
        }
    }

    _settextposition( 7, 1 );
    printf("Reading in messages    %s", clrstr );
    _settextposition( 7, 23 );
    printf("(%d messages to sort)", incount);
    fclose(tp1);
    tp1 = fopen(tfile1, "w+");

    /* sort records in temporary file2 */
    _settextposition( 8, 2 );
    printf("Sorting messages....moving message ");
    outcount=0;
    strcpy( str, "000000000000000" );
    strcpy( thrstr, "999999999999999" );
    while ( outcount < incount )
    {
        i=0;
        j=0;
        rewind( tp2 );
        while ( fgets(recstr, 80, tp2) != NULL )
        {
            i++;
            if ( ( strncmp( recstr, str, 15 ) > 0 ) &&
               ( strncmp( recstr, thrstr, 15 ) < 0 ))
            {
                strset(daterec, ' ' );
                strncpy( daterec, recstr + 16, 10 );
                strncpy( thrstr, recstr, 15 );
                j=i;
            }
        }
        outcount++;
        _settextposition( 8, 52 );
        printf("%s", clrstr );
        _settextposition( 8, 37 );
        printf("%d to position %d", j, outcount );
        fputs(daterec, tp1);
        strncpy( str, thrstr, 15 );
        strcpy( thrstr, "999999999999999" );
    }

    _settextposition( 8, 1 );
    printf("Sorting messages    %s", clrstr );
    rewind( tp1 );
    _settextposition( 9, 2 );
    printf("Writing sorted file....writing message 1");
    i=0;
    rewind( in );
    incount=0;

    /* write out records in sorted order */
    while ( fgets(thrstr, 80, tp1) != NULL )
    {
        if ( incount > atoi(thrstr))
        {
            rewind( in );
            incount=0;
        }
        extflag=0;
        while ( incount != atoi(thrstr))
        {
            fgets(recstr, 80, in);
            incount++;
        }
        i++;
        while ( extflag < 1 )
        {
            fputs(recstr, out);
            _settextposition( 9, 41 );
            printf("%d", i );
            fgets(recstr, 80, in);
            incount++;
            str1=recstr[0];
            if ( str1 == numsign )
                extflag=1;
            str1=recstr[2];
            if ( ( str1 == ' ' ) && ( extflag == 1 ))
                extflag=2;
            else
                extflag=0;
            if (feof(in) != 0)
                extflag=2;
        }
    }

    _settextposition( 9, 1 );
    printf("Writing sorted file    %s", clrstr );
    _settextposition( 10, 1 );
    printf("Done  " );
    printf("\n");
    printf("\n");

    eoj:;

    fclose(in);
    fclose(out);
    fclose(tp1);
    fclose(tp2);
    remove(tfile1);
    remove(tfile2);

    /* restore cursor */
    _asm
        {
        mov    cl, 7
        mov    ch, 6
        mov    ah, 1
        int    10h
        }


}
